<template>
  <div v-if="!isInstalled" class="install-banner">
    <p>¡Instala nuestra aplicación para una mejor experiencia!</p>
    <button class="button" @click="installApp">Instalar</button>
  </div>
</template>

<script lang="ts">
declare global {
  interface Navigator {
    standalone?: boolean;
  }
}

export default {
  name: 'install-button',
  data() {
    return {
      deferredPrompt: null as any | null, // Tipificamos deferredPrompt como any | null
      isInstalled: false
    }
  },
  created() {
    window.addEventListener('beforeinstallprompt', (event: Event) => {
      event.preventDefault();
      this.deferredPrompt = event;
    });

    window.addEventListener('appinstalled', () => {
      this.isInstalled = true;
      console.log('Aplicación instalada');
    });

    if (window.matchMedia('(display-mode: standalone)').matches || window.navigator.standalone) {
      this.isInstalled = true;
    }
  },
  methods: {
    async installApp() {
      if (this.deferredPrompt) {
        this.deferredPrompt.prompt();
        const choiceResult = await this.deferredPrompt.userChoice;

        if (choiceResult.outcome === 'accepted') {
          console.log('El usuario aceptó la instalación');
        } else {
          console.log('El usuario declinó la instalación');
        }

        this.deferredPrompt = null;
      } else {
        alert('La aplicación aún no es elegible para la instalación.');
      }
    }
  }
}
</script>

<style scoped>
.install-banner {
  position: fixed;
  top: 0;
  left: 0;
  width: calc(100% - 20px);
  display: flex;
  justify-content: space-between;
  align-items: center;
  background-color: #f4f4f4;
  padding: 10px;
  border: 1px solid #ddd;
  border-radius: 5px;
  margin: 10px;
  box-sizing: border-box;
}

.install-banner p {
  margin: 0;
  font-size: 16px;
}

.button {
  padding: 10px 20px;
  border: none;
  border-radius: 5px;
  background-color: #007bff;
  color: white;
  cursor: pointer;
  font-size: 16px;
  transition: background-color 0.3s;
}

.button:hover {
  background-color: #0056b3;
}
</style>
